#define  thd_t  (ithd % _NBT)
#define  thd_z  (ithd /(_NBT) % _NBZ)
#define  thd_y  (ithd /(_NBT*_NBZ) % _NBY)
#define  thd_x  (ithd /(_NBT*_NBZ*_NBY) % _NBX)
#define  blk_t  (iblk % _NGT)
#define  blk_z  (iblk /(_NGT) % _NGZ)
#define  blk_y  (iblk /(_NGT*_NGZ) % _NGY)
#define  blk_x  (iblk /(_NGT*_NGZ*_NGY) % _NGX)

static __device__ __inline__ void 
mult_hop_kernel( float ytr[],
                 float yti[],
                 const  cuhqfield *yo,
                 const cuhgvfield *ue,
                 const cuhgvfield *uo,
                 const int *ieo)
{
  int ithd = threadIdx.x;
  int iblk = blockIdx.x;

  { 
    int itb    = thd_t + blk_t*_NBT;
    int iz     = thd_z + blk_z*_NBZ;
    int iy     = thd_y + blk_y*_NBY;
    int ix     = thd_x + blk_x*_NBX;
    int ieoxyz = ((*ieo)+(iz+1)+(iy+1)+(ix+1))%2;
    int it     = (itb+1-ieoxyz)*2+ieoxyz-1;
    int itp = (((it+1+NT)%NT)+1)/2-ieoxyz;
    int ithd_t_up = ithd + (itp % _NBT) - thd_t;
    int iblk_t_up = iblk + (itp / _NBT) - blk_t;
    __align__(16) float4 yri[CSH];
#ifdef _USE_TEXFETCH_
    yri[1] = __loady_tex(tex_yori,ithd_t_up,1,iblk_t_up);
    yri[2] = __loady_tex(tex_yori,ithd_t_up,2,iblk_t_up);
    yri[4] = __loady_tex(tex_yori,ithd_t_up,4,iblk_t_up);
    yri[5] = __loady_tex(tex_yori,ithd_t_up,5,iblk_t_up);
#else
    yri[1] = (*yo).b[iblk_t_up].yri[1].c[ithd_t_up];
    yri[2] = (*yo).b[iblk_t_up].yri[2].c[ithd_t_up];
    yri[4] = (*yo).b[iblk_t_up].yri[4].c[ithd_t_up];
    yri[5] = (*yo).b[iblk_t_up].yri[5].c[ithd_t_up];
#endif
    __align__(16) float4 uri[COL];
#ifdef _USE_TEXFETCH_
    uri[0] = __loadu_tex(tex_ueri,ithd,0,3,iblk);
    uri[1] = __loadu_tex(tex_ueri,ithd,1,3,iblk);
    uri[2] = __loadu_tex(tex_ueri,ithd,2,3,iblk);
#else
    uri[0] = (*ue).b[iblk].v[3].uri[0].c[ithd];
    uri[1] = (*ue).b[iblk].v[3].uri[1].c[ithd];
    uri[2] = (*ue).b[iblk].v[3].uri[2].c[ithd];
#endif

#if _FERMI_BOUNDARY_TYPE_T == APBC
    //
    //  Set Anti-Periodic boundary conditon at (Fortran: itt=NTT (C: itt=NTT-1))
    //
    // flag = -1, itt=NTT-1
    //      = +1  itt<NTT-1
    //
    float flag = (float)(1-((it+1)/_NTT)*2);
    yri[1].x = yri[1].x * flag;
    yri[1].y = yri[1].y * flag;
    yri[1].z = yri[1].z * flag;
    yri[1].w = yri[1].w * flag;
    yri[2].x = yri[2].x * flag;
    yri[2].y = yri[2].y * flag;
    yri[2].z = yri[2].z * flag;
    yri[2].w = yri[2].w * flag;
    yri[4].x = yri[4].x * flag;
    yri[4].y = yri[4].y * flag;
    yri[4].z = yri[4].z * flag;
    yri[4].w = yri[4].w * flag;
    yri[5].x = yri[5].x * flag;
    yri[5].y = yri[5].y * flag;
    yri[5].z = yri[5].z * flag;
    yri[5].w = yri[5].w * flag;
#endif

    cu_mult_forw_t(uri,yri,ytr,yti);
  }

  { 
    int itb    = thd_t + blk_t*_NBT;
    int iz     = thd_z + blk_z*_NBZ;
    int iy     = thd_y + blk_y*_NBY;
    int ix     = thd_x + blk_x*_NBX;
    int ieoxyz = ((*ieo)+(iz+1)+(iy+1)+(ix+1))%2;
    int it     = (itb+1-ieoxyz)*2+ieoxyz-1;
    int itd=(((it-1+NT)%NT)+1)/2-ieoxyz;
    int ithd_t_dn = ithd + (itd % _NBT) - thd_t;
    int iblk_t_dn = iblk + (itd / _NBT) - blk_t;
    __align__(16) float4 yri[CSH];
#ifdef _USE_TEXFETCH_
    yri[0] = __loady_tex(tex_yori,ithd_t_dn,0,iblk_t_dn);
    yri[1] = __loady_tex(tex_yori,ithd_t_dn,1,iblk_t_dn);
    yri[3] = __loady_tex(tex_yori,ithd_t_dn,3,iblk_t_dn);
    yri[4] = __loady_tex(tex_yori,ithd_t_dn,4,iblk_t_dn);
#else
    yri[0] = (*yo).b[iblk_t_dn].yri[0].c[ithd_t_dn];
    yri[1] = (*yo).b[iblk_t_dn].yri[1].c[ithd_t_dn];
    yri[3] = (*yo).b[iblk_t_dn].yri[3].c[ithd_t_dn];
    yri[4] = (*yo).b[iblk_t_dn].yri[4].c[ithd_t_dn];
#endif
    __align__(16) float4 uri[COL];
#ifdef _USE_TEXFETCH_
    uri[0] = __loadu_tex(tex_uori,ithd_t_dn,0,3,iblk_t_dn);
    uri[1] = __loadu_tex(tex_uori,ithd_t_dn,1,3,iblk_t_dn);
    uri[2] = __loadu_tex(tex_uori,ithd_t_dn,2,3,iblk_t_dn);
#else
    uri[0] = (*uo).b[iblk_t_dn].v[3].uri[0].c[ithd_t_dn];
    uri[1] = (*uo).b[iblk_t_dn].v[3].uri[1].c[ithd_t_dn];
    uri[2] = (*uo).b[iblk_t_dn].v[3].uri[2].c[ithd_t_dn];
#endif

#if _FERMI_BOUNDARY_TYPE_T == APBC
    //
    //  Set Anti-Periodic boundary conditon at (Fortran: itt=1 (C: itt=0))
    //
    // flag = -1, itt=0
    //      = +1  itt>0
    //
    float flag = (float)(1-((_NTT-it)/_NTT)*2);
    yri[0].x = yri[0].x * flag;
    yri[0].y = yri[0].y * flag;
    yri[0].z = yri[0].z * flag;
    yri[0].w = yri[0].w * flag;
    yri[1].x = yri[1].x * flag;
    yri[1].y = yri[1].y * flag;
    yri[1].z = yri[1].z * flag;
    yri[1].w = yri[1].w * flag;
    yri[3].x = yri[3].x * flag;
    yri[3].y = yri[3].y * flag;
    yri[3].z = yri[3].z * flag;
    yri[3].w = yri[3].w * flag;
    yri[4].x = yri[4].x * flag;
    yri[4].y = yri[4].y * flag;
    yri[4].z = yri[4].z * flag;
    yri[4].w = yri[4].w * flag;
#endif

    cu_mult_back_t(uri,yri,ytr,yti);
  }

  { 
    int iz      = thd_z + blk_z*_NBZ;
    int ithd_z_up = ithd + ((((iz+1+NZ) % NZ) % _NBZ) - thd_z)*_NBT;
    int iblk_z_up = iblk + ((((iz+1+NZ) % NZ) / _NBZ) - blk_z)*_NGT;
    __align__(16) float4 yri[CSH];
#ifdef _USE_TEXFETCH_
    yri[0] = __loady_tex(tex_yori,ithd_z_up,0,iblk_z_up);
    yri[1] = __loady_tex(tex_yori,ithd_z_up,1,iblk_z_up);
    yri[2] = __loady_tex(tex_yori,ithd_z_up,2,iblk_z_up);
    yri[3] = __loady_tex(tex_yori,ithd_z_up,3,iblk_z_up);
    yri[4] = __loady_tex(tex_yori,ithd_z_up,4,iblk_z_up);
    yri[5] = __loady_tex(tex_yori,ithd_z_up,5,iblk_z_up);
#else
    yri[0] = (*yo).b[iblk_z_up].yri[0].c[ithd_z_up];
    yri[1] = (*yo).b[iblk_z_up].yri[1].c[ithd_z_up];
    yri[2] = (*yo).b[iblk_z_up].yri[2].c[ithd_z_up];
    yri[3] = (*yo).b[iblk_z_up].yri[3].c[ithd_z_up];
    yri[4] = (*yo).b[iblk_z_up].yri[4].c[ithd_z_up];
    yri[5] = (*yo).b[iblk_z_up].yri[5].c[ithd_z_up];
#endif
    __align__(16) float4 uri[COL];
#ifdef _USE_TEXFETCH_
    uri[0] = __loadu_tex(tex_ueri,ithd,0,2,iblk);
    uri[1] = __loadu_tex(tex_ueri,ithd,1,2,iblk);
    uri[2] = __loadu_tex(tex_ueri,ithd,2,2,iblk);
#else
    uri[0] = (*ue).b[iblk].v[2].uri[0].c[ithd];
    uri[1] = (*ue).b[iblk].v[2].uri[1].c[ithd];
    uri[2] = (*ue).b[iblk].v[2].uri[2].c[ithd];
#endif
    cu_mult_forw_z(uri,yri,ytr,yti);
  }

  { 
    int iz     = thd_z + blk_z*_NBZ;
    int ithd_z_dn = ithd + ((((iz-1+NZ) % NZ) % _NBZ) - thd_z)*_NBT;
    int iblk_z_dn = iblk + ((((iz-1+NZ) % NZ) / _NBZ) - blk_z)*_NGT;
    __align__(16) float4 yri[CSH];
#ifdef _USE_TEXFETCH_
    yri[0] = __loady_tex(tex_yori,ithd_z_dn,0,iblk_z_dn);
    yri[1] = __loady_tex(tex_yori,ithd_z_dn,1,iblk_z_dn);
    yri[2] = __loady_tex(tex_yori,ithd_z_dn,2,iblk_z_dn);
    yri[3] = __loady_tex(tex_yori,ithd_z_dn,3,iblk_z_dn);
    yri[4] = __loady_tex(tex_yori,ithd_z_dn,4,iblk_z_dn);
    yri[5] = __loady_tex(tex_yori,ithd_z_dn,5,iblk_z_dn);
#else
    yri[0] = (*yo).b[iblk_z_dn].yri[0].c[ithd_z_dn];
    yri[1] = (*yo).b[iblk_z_dn].yri[1].c[ithd_z_dn];
    yri[2] = (*yo).b[iblk_z_dn].yri[2].c[ithd_z_dn];
    yri[3] = (*yo).b[iblk_z_dn].yri[3].c[ithd_z_dn];
    yri[4] = (*yo).b[iblk_z_dn].yri[4].c[ithd_z_dn];
    yri[5] = (*yo).b[iblk_z_dn].yri[5].c[ithd_z_dn];
#endif
    __align__(16) float4 uri[COL];
#ifdef _USE_TEXFETCH_
    uri[0] = __loadu_tex(tex_uori,ithd_z_dn,0,2,iblk_z_dn);
    uri[1] = __loadu_tex(tex_uori,ithd_z_dn,1,2,iblk_z_dn);
    uri[2] = __loadu_tex(tex_uori,ithd_z_dn,2,2,iblk_z_dn);
#else
    uri[0] = (*uo).b[iblk_z_dn].v[2].uri[0].c[ithd_z_dn];
    uri[1] = (*uo).b[iblk_z_dn].v[2].uri[1].c[ithd_z_dn];
    uri[2] = (*uo).b[iblk_z_dn].v[2].uri[2].c[ithd_z_dn];
#endif
    cu_mult_back_z(uri,yri,ytr,yti);
  }

  { 
    int iy     = thd_y + blk_y*_NBY;
    int ithd_y_up = ithd + ((((iy+1+NY) % NY) % _NBY) - thd_y)*(_NBT*_NBZ);
    int iblk_y_up = iblk + ((((iy+1+NY) % NY) / _NBY) - blk_y)*(_NGT*_NGZ);
    __align__(16) float4 yri[CSH];
#ifdef _USE_TEXFETCH_
    yri[0] = __loady_tex(tex_yori,ithd_y_up,0,iblk_y_up);
    yri[1] = __loady_tex(tex_yori,ithd_y_up,1,iblk_y_up);
    yri[2] = __loady_tex(tex_yori,ithd_y_up,2,iblk_y_up);
    yri[3] = __loady_tex(tex_yori,ithd_y_up,3,iblk_y_up);
    yri[4] = __loady_tex(tex_yori,ithd_y_up,4,iblk_y_up);
    yri[5] = __loady_tex(tex_yori,ithd_y_up,5,iblk_y_up);
#else
    yri[0] = (*yo).b[iblk_y_up].yri[0].c[ithd_y_up];
    yri[1] = (*yo).b[iblk_y_up].yri[1].c[ithd_y_up];
    yri[2] = (*yo).b[iblk_y_up].yri[2].c[ithd_y_up];
    yri[3] = (*yo).b[iblk_y_up].yri[3].c[ithd_y_up];
    yri[4] = (*yo).b[iblk_y_up].yri[4].c[ithd_y_up];
    yri[5] = (*yo).b[iblk_y_up].yri[5].c[ithd_y_up];
#endif
    __align__(16) float4 uri[COL];
#ifdef _USE_TEXFETCH_
    uri[0] = __loadu_tex(tex_ueri,ithd,0,1,iblk);
    uri[1] = __loadu_tex(tex_ueri,ithd,1,1,iblk);
    uri[2] = __loadu_tex(tex_ueri,ithd,2,1,iblk);
#else
    uri[0] = (*ue).b[iblk].v[1].uri[0].c[ithd];
    uri[1] = (*ue).b[iblk].v[1].uri[1].c[ithd];
    uri[2] = (*ue).b[iblk].v[1].uri[2].c[ithd];
#endif
    cu_mult_forw_y(uri,yri,ytr,yti);
  }

  { 
    int iy     = thd_y + blk_y*_NBY;
    int ithd_y_dn = ithd + ((((iy-1+NY) % NY) % _NBY) - thd_y)*(_NBT*_NBZ);
    int iblk_y_dn = iblk + ((((iy-1+NY) % NY) / _NBY) - blk_y)*(_NGT*_NGZ);
    __align__(16) float4 yri[CSH];
#ifdef _USE_TEXFETCH_
    yri[0] = __loady_tex(tex_yori,ithd_y_dn,0,iblk_y_dn);
    yri[1] = __loady_tex(tex_yori,ithd_y_dn,1,iblk_y_dn);
    yri[2] = __loady_tex(tex_yori,ithd_y_dn,2,iblk_y_dn);
    yri[3] = __loady_tex(tex_yori,ithd_y_dn,3,iblk_y_dn);
    yri[4] = __loady_tex(tex_yori,ithd_y_dn,4,iblk_y_dn);
    yri[5] = __loady_tex(tex_yori,ithd_y_dn,5,iblk_y_dn);
#else
    yri[0] = (*yo).b[iblk_y_dn].yri[0].c[ithd_y_dn];
    yri[1] = (*yo).b[iblk_y_dn].yri[1].c[ithd_y_dn];
    yri[2] = (*yo).b[iblk_y_dn].yri[2].c[ithd_y_dn];
    yri[3] = (*yo).b[iblk_y_dn].yri[3].c[ithd_y_dn];
    yri[4] = (*yo).b[iblk_y_dn].yri[4].c[ithd_y_dn];
    yri[5] = (*yo).b[iblk_y_dn].yri[5].c[ithd_y_dn];
#endif
    __align__(16) float4 uri[COL];
#ifdef _USE_TEXFETCH_
    uri[0] = __loadu_tex(tex_uori,ithd_y_dn,0,1,iblk_y_dn);
    uri[1] = __loadu_tex(tex_uori,ithd_y_dn,1,1,iblk_y_dn);
    uri[2] = __loadu_tex(tex_uori,ithd_y_dn,2,1,iblk_y_dn);
#else
    uri[0] = (*uo).b[iblk_y_dn].v[1].uri[0].c[ithd_y_dn];
    uri[1] = (*uo).b[iblk_y_dn].v[1].uri[1].c[ithd_y_dn];
    uri[2] = (*uo).b[iblk_y_dn].v[1].uri[2].c[ithd_y_dn];
#endif
    cu_mult_back_y(uri,yri,ytr,yti);
  }

  { 
    int ix     = thd_x + blk_x*_NBX;
    int ithd_x_up = ithd + ((((ix+1+NX) % NX) % _NBX) - thd_x)*(_NBT*_NBZ*_NBY);
    int iblk_x_up = iblk + ((((ix+1+NX) % NX) / _NBX) - blk_x)*(_NGT*_NGZ*_NGY);
    __align__(16) float4 yri[CSH];
#ifdef _USE_TEXFETCH_
    yri[0] = __loady_tex(tex_yori,ithd_x_up,0,iblk_x_up);
    yri[1] = __loady_tex(tex_yori,ithd_x_up,1,iblk_x_up);
    yri[2] = __loady_tex(tex_yori,ithd_x_up,2,iblk_x_up);
    yri[3] = __loady_tex(tex_yori,ithd_x_up,3,iblk_x_up);
    yri[4] = __loady_tex(tex_yori,ithd_x_up,4,iblk_x_up);
    yri[5] = __loady_tex(tex_yori,ithd_x_up,5,iblk_x_up);
#else
    yri[0] = (*yo).b[iblk_x_up].yri[0].c[ithd_x_up];
    yri[1] = (*yo).b[iblk_x_up].yri[1].c[ithd_x_up];
    yri[2] = (*yo).b[iblk_x_up].yri[2].c[ithd_x_up];
    yri[3] = (*yo).b[iblk_x_up].yri[3].c[ithd_x_up];
    yri[4] = (*yo).b[iblk_x_up].yri[4].c[ithd_x_up];
    yri[5] = (*yo).b[iblk_x_up].yri[5].c[ithd_x_up];
#endif
    __align__(16) float4 uri[COL];
#ifdef _USE_TEXFETCH_
    uri[0] = __loadu_tex(tex_ueri,ithd,0,0,iblk);
    uri[1] = __loadu_tex(tex_ueri,ithd,1,0,iblk);
    uri[2] = __loadu_tex(tex_ueri,ithd,2,0,iblk);
#else
    uri[0] = (*ue).b[iblk].v[0].uri[0].c[ithd];
    uri[1] = (*ue).b[iblk].v[0].uri[1].c[ithd];
    uri[2] = (*ue).b[iblk].v[0].uri[2].c[ithd];
#endif
    cu_mult_forw_x(uri,yri,ytr,yti);
  }

  { 
    int ix     = thd_x + blk_x*_NBX;
    int ithd_x_dn = ithd + ((((ix-1+NX) % NX) % _NBX) - thd_x)*(_NBT*_NBZ*_NBY);
    int iblk_x_dn = iblk + ((((ix-1+NX) % NX) / _NBX) - blk_x)*(_NGT*_NGZ*_NGY);
    __align__(16) float4 yri[CSH];
#ifdef _USE_TEXFETCH_
    yri[0] = __loady_tex(tex_yori,ithd_x_dn,0,iblk_x_dn);
    yri[1] = __loady_tex(tex_yori,ithd_x_dn,1,iblk_x_dn);
    yri[2] = __loady_tex(tex_yori,ithd_x_dn,2,iblk_x_dn);
    yri[3] = __loady_tex(tex_yori,ithd_x_dn,3,iblk_x_dn);
    yri[4] = __loady_tex(tex_yori,ithd_x_dn,4,iblk_x_dn);
    yri[5] = __loady_tex(tex_yori,ithd_x_dn,5,iblk_x_dn);
#else
    yri[0] = (*yo).b[iblk_x_dn].yri[0].c[ithd_x_dn];
    yri[1] = (*yo).b[iblk_x_dn].yri[1].c[ithd_x_dn];
    yri[2] = (*yo).b[iblk_x_dn].yri[2].c[ithd_x_dn];
    yri[3] = (*yo).b[iblk_x_dn].yri[3].c[ithd_x_dn];
    yri[4] = (*yo).b[iblk_x_dn].yri[4].c[ithd_x_dn];
    yri[5] = (*yo).b[iblk_x_dn].yri[5].c[ithd_x_dn];
#endif
    __align__(16) float4 uri[COL];
#ifdef _USE_TEXFETCH_
    uri[0] = __loadu_tex(tex_uori,ithd_x_dn,0,0,iblk_x_dn);
    uri[1] = __loadu_tex(tex_uori,ithd_x_dn,1,0,iblk_x_dn);
    uri[2] = __loadu_tex(tex_uori,ithd_x_dn,2,0,iblk_x_dn);
#else
    uri[0] = (*uo).b[iblk_x_dn].v[0].uri[0].c[ithd_x_dn];
    uri[1] = (*uo).b[iblk_x_dn].v[0].uri[1].c[ithd_x_dn];
    uri[2] = (*uo).b[iblk_x_dn].v[0].uri[2].c[ithd_x_dn];
#endif
    cu_mult_back_x(uri,yri,ytr,yti);
  }

}

static __global__ void 
assign_mult_hop_kernel(       cuhqfield  *yde,
                       const  cuhqfield  *yo,
                       const cuhgvfield  *ue,
                       const cuhgvfield  *uo,
                       const        int  *ieo,
                       const cuhclvfield *fclinve){
////////////////////////////////////////////////////////////////////////////////
// Multiply odd->even/even->odd hopping matrix : yde = Fee Meo yo
//
//     yde : even/odd site fermion (ieo=0/1) (output)
//      yo : odd/even site fermion (ieo=0/1) (input)
//      ue : even/odd site gauge link (ieo=0/1)
//      uo : odd/even site gauge link (ieo=0/1)
//     ieo : operate even/odd site
//           ieo=0 for even site link
//           ieo=1 for odd  site link
// fclinve : even/odd site inverse clover term (ieo=0/1)
////////////////////////////////////////////////////////////////////////////////
  __align__(16) float ytr[CLSP],yti[CLSP];

  ytr[0] =0.0f;
  ytr[1] =0.0f;
  ytr[2] =0.0f;
  ytr[3] =0.0f;
  ytr[4] =0.0f;
  ytr[5] =0.0f;
  ytr[6] =0.0f;
  ytr[7] =0.0f;
  ytr[8] =0.0f;
  ytr[9] =0.0f;
  ytr[10]=0.0f;
  ytr[11]=0.0f;
  yti[0] =0.0f;
  yti[1] =0.0f;
  yti[2] =0.0f;
  yti[3] =0.0f;
  yti[4] =0.0f;
  yti[5] =0.0f;
  yti[6] =0.0f;
  yti[7] =0.0f;
  yti[8] =0.0f;
  yti[9] =0.0f;
  yti[10]=0.0f;
  yti[11]=0.0f;

  mult_hop_kernel(ytr,yti,yo,ue,uo,ieo);
  int ithd = threadIdx.x;
  int iblk = blockIdx.x;
  cu_mult_clover_term(&((*fclinve).b[iblk]),&ithd,ytr,yti);

#ifdef _SF
  set_sf_boundary_q(ytr,yti,ithd,iblk,ieo);
#endif

  (*yde).b[iblk].yri[0].c[ithd] = *(float4 *)(ytr+0);
  (*yde).b[iblk].yri[1].c[ithd] = *(float4 *)(ytr+4);
  (*yde).b[iblk].yri[2].c[ithd] = *(float4 *)(ytr+8);
  (*yde).b[iblk].yri[3].c[ithd] = *(float4 *)(yti+0);
  (*yde).b[iblk].yri[4].c[ithd] = *(float4 *)(yti+4);
  (*yde).b[iblk].yri[5].c[ithd] = *(float4 *)(yti+8);

}

static __global__ void 
assign_mult_hop_kernel(       cuhqfield *yde,
                       const  cuhqfield *yo,
                       const cuhgvfield *ue,
                       const cuhgvfield *uo,
                       const int        *ieo)
////////////////////////////////////////////////////////////////////////////////
// Multiply odd->even/even->odd hopping matrix : yde =  Meo yo
//
//     yde : even/odd site fermion (ieo=0/1) (output)
//      yo : odd/even site fermion (ieo=0/1) (input)
//      ue : even/odd site gauge link (ieo=0/1)
//      uo : odd/even site gauge link (ieo=0/1)
//     ieo : operate even/odd site
//           ieo=0 for even site link
//           ieo=1 for odd  site link
////////////////////////////////////////////////////////////////////////////////
{
  __align__(16) float ytr[CLSP],yti[CLSP];

  ytr[0] =0.0f;
  ytr[1] =0.0f;
  ytr[2] =0.0f;
  ytr[3] =0.0f;
  ytr[4] =0.0f;
  ytr[5] =0.0f;
  ytr[6] =0.0f;
  ytr[7] =0.0f;
  ytr[8] =0.0f;
  ytr[9] =0.0f;
  ytr[10]=0.0f;
  ytr[11]=0.0f;
  yti[0] =0.0f;
  yti[1] =0.0f;
  yti[2] =0.0f;
  yti[3] =0.0f;
  yti[4] =0.0f;
  yti[5] =0.0f;
  yti[6] =0.0f;
  yti[7] =0.0f;
  yti[8] =0.0f;
  yti[9] =0.0f;
  yti[10]=0.0f;
  yti[11]=0.0f;

  mult_hop_kernel(ytr,yti,yo,ue,uo,ieo);
  int ithd = threadIdx.x;
  int iblk = blockIdx.x;

#ifdef _SF
  set_sf_boundary_q(ytr,yti,ithd,iblk,ieo);
#endif

  (*yde).b[iblk].yri[0].c[ithd] = *(float4 *)(ytr+0);
  (*yde).b[iblk].yri[1].c[ithd] = *(float4 *)(ytr+4);
  (*yde).b[iblk].yri[2].c[ithd] = *(float4 *)(ytr+8);
  (*yde).b[iblk].yri[3].c[ithd] = *(float4 *)(yti+0);
  (*yde).b[iblk].yri[4].c[ithd] = *(float4 *)(yti+4);
  (*yde).b[iblk].yri[5].c[ithd] = *(float4 *)(yti+8);

}

static void 
assign_mult_hop(      cuhqfield   *yde,
                const cuhqfield   *yo,
                const cuhgvfield  *ue,
                const cuhgvfield  *uo,
                const int         *ieo,
                const cuhclvfield *fclinve = NULL)
{
#ifdef _DEBUG_
  startTimer(multtime);
#endif

#ifdef _USE_TEXFETCH_
  CUDA_SAFE_CALL(cudaBindTexture(0,tex_yori,yo,sizeof(cuhqfield)));
  CUDA_SAFE_CALL(cudaBindTexture(0,tex_ueri,ue,sizeof(cuhgvfield)));
  CUDA_SAFE_CALL(cudaBindTexture(0,tex_uori,uo,sizeof(cuhgvfield)));
#endif

  if (fclinve == NULL) {
    assign_mult_hop_kernel<<<BLOCKS,THREADS>>>(yde,yo,ue,uo,ieo);
    flop_mult_count += MULT_WD_WIL;
  } else {
    assign_mult_hop_kernel<<<BLOCKS,THREADS>>>(yde,yo,ue,uo,ieo,fclinve);
    flop_mult_count += MULT_WD_CLV;
  }
  CUT_CHECK_ERROR("assign_mult_hop kernel execution faild");

#ifdef _USE_TEXFETCH_
  CUDA_SAFE_CALL(cudaUnbindTexture(tex_yori));
  CUDA_SAFE_CALL(cudaUnbindTexture(tex_ueri));
  CUDA_SAFE_CALL(cudaUnbindTexture(tex_uori));
#endif

  _multiter_ += 1;
#ifdef _DEBUG_
  stopTimer(multtime);
#endif
}

#undef  thd_t
#undef  thd_z
#undef  thd_y
#undef  thd_x
#undef  blk_t
#undef  blk_z
#undef  blk_y
#undef  blk_x
