#include "qmx_lib.h"

int main(int argc, char* argv[]) {

  int local_rank,remote_rank;

  qmx_init();

  int myrank = qmx_get_local_rank();
  printf("%d\n",myrank);

  unsigned int NDAT=100;
  double et0,et1;

  qmx_clock(&et0);
  for (int i=0; i< NDAT; i++) {
    qmx_barrier();
  }
  qmx_clock(&et1);
  et1 = et1 - et0;
  printf("qmx_barrier(%d): %d [called] %14.6E [sec] %14.6f [usec/call]\n",myrank,NDAT,et1,et1*1000*1000/NDAT);

  {
    int data[NDAT];
    for (int i=0; i<NDAT; i++) {
      data[i] = qmx_get_local_rank()*(i+1);
    }
    qmx_sumcast_int(NDAT, data);
    for (int i=0; i<NDAT; i++) {
      printf("qmx_sumcast_int(%d): data[%d] = %d\n",myrank,i,data[i]/(i+1));
    }
  }
  {
    double data[NDAT];
    for (int i=0; i<NDAT; i++) {
      data[i] = (double)(qmx_get_local_rank()*(i+1))*sqrt(2.0);
    }
    qmx_sumcast_double(NDAT, data);
    for (int i=0; i<NDAT; i++) {
      printf("qmx_sumcast_double(%d): data[%d] = %24.15E\n",myrank,i,data[i]/(i+1));
    }
  }

  {
    float data[NDAT];
    for (int i=0; i<NDAT; i++) {
      data[i] = (float)(qmx_get_local_rank()*(i+1));
    }
    qmx_bcast_float(NDAT, data, 3);
    for (int i=0; i<NDAT; i++) {
      printf("qmx_bcast_float(%d): data[%d] = %14.6e\n",myrank,i,data[i]/(i+1));
    }
  }

  qmx_finalize();


  return (1);
}
